Magellan Linux

Contents of /tags/grubby-8_29/new-kernel-pkg

Parent Directory Parent Directory | Revision Log Revision Log


Revision 2267 - (show annotations) (download)
Mon Oct 21 14:16:22 2013 UTC (10 years, 5 months ago) by niro
File size: 23084 byte(s)
tagged 'grubby-8_29'
1 #!/bin/bash
2 # $Id$
3 #
4 # new-kernel-pkg
5 # Invoked upon installation or removal of a kernel package, the following
6 # tasks are/can be done here:
7 # creation/removal of initrd
8 # run of depmod/removal of depmod generated files
9 # addition/removal of kernel images from grub/lilo configuration (via grubby)
10 #
11 # Copyright 2002-2008 Red Hat, Inc. All rights reserved.
12 # modified for Magellan-Linux by Niels Rogalla <niro@magellan-linux.de>
13 #
14 # This program is free software; you can redistribute it and/or modify
15 # it under the terms of the GNU General Public License as published by
16 # the Free Software Foundation; either version 2 of the License, or
17 # (at your option) any later version.
18 #
19 # This program is distributed in the hope that it will be useful,
20 # but WITHOUT ANY WARRANTY; without even the implied warranty of
21 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
22 # GNU General Public License for more details.
23 #
24 # You should have received a copy of the GNU General Public License
25 # along with this program. If not, see <http://www.gnu.org/licenses/>.
26 #
27
28 read_os_release()
29 {
30 local NAME
31 local ID
32 local Version
33 local Version_ID
34 local PRETTY_NAME
35 local ANSI_COLOR
36 local CPE_NAME
37
38 if [[ -f /etc/os-release ]]
39 then
40 source /etc/os-release
41
42 case $1 in
43 name) echo "${NAME}" ;;
44 id) echo "${ID}" ;;
45 version) echo "${Version}" ;;
46 version_id) echo "${Version_ID}" ;;
47 pretty_name) echo "${PRETTY_NAME}" ;;
48 ansi_color) echo "${ANSI_COLOR}" ;;
49 cpe_name) echo "${CPE_NAME}" ;;
50 esac
51 fi
52 }
53
54 PATH=/sbin:/bin:$PATH
55
56 lilo=/sbin/lilo
57
58 # some defaults that are sane for most arches
59 kernelName=kernel
60
61 if [ -x ./grubby ]
62 then
63 grubby=./grubby
64 else
65 grubby=/sbin/grubby
66 fi
67
68 [ -f /etc/conf.d/grubby ] && . /etc/conf.d/grubby
69 [ -f /etc/conf.d/grubby-uboot ] && . /etc/conf.d/grubby-uboot
70
71 cfgGrub2=""
72 cfgGrub2Efi=""
73 cfgGrub=""
74 cfgLilo=""
75 cfgExtlinux=""
76 cfguBoot=""
77 runLilo=""
78 grubConfig=""
79 grub2Config=""
80 grub2EfiConfig=""
81 extlinuxConfig=""
82
83 ARCH=$(uname -m)
84
85 if [[ ${ARCH} = ia64 ]]
86 then
87 liloConfig=/boot/efi/EFI/redhat/elilo.conf
88 bootPrefix=/boot/efi/EFI/redhat
89 liloFlag=elilo
90 isx86=""
91 elif [[ ${ARCH} = ppc64 ]] || [[ ${ARCH} = ppc ]]
92 then
93 liloConfig=/etc/yaboot.conf
94 grub2Config=/boot/grub/grub.cfg
95 bootPrefix=/boot
96 lilo=/sbin/ybin
97 liloFlag=yaboot
98 runLilo="yes"
99 isx86=""
100 elif [[ ${ARCH} = sparc ]] || [[ ${ARCH} = sparc64 ]]
101 then
102 liloConfig=/etc/silo.conf
103 bootPrefix=/boot
104 liloFlag=silo
105 lilo=/sbin/silo
106 isx86=""
107 elif [[ ${ARCH} = s390 ]] || [[ ${ARCH} = s390x ]]
108 then
109 liloConfig=/etc/zipl.conf
110 bootPrefix=/boot
111 liloFlag=zipl
112 lilo=/sbin/zipl
113 runLilo="yes"
114 isx86=""
115 elif [[ ${ARCH} =~ armv[5|7].*l ]]
116 then
117 liloConfig=""
118 bootPrefix=/boot
119 extlinuxConfig=$(readlink -f /etc/extlinux.conf 2>/dev/null)
120 ubootDir=${UBOOT_DIR:-"/boot"}
121 ubootScript=$ubootDir/${UBOOT_SCR:-"boot.scr"}
122 ubootKList=${UBOOT_KLIST:-"klist.txt"}
123 ubootDevice=/dev/${UBOOT_DEVICE:-"mmcblk0p1"}
124 ubootDefaultImage=${UBOOT_UIMAGE:-"uImage"}
125 ubootDefaultInitrd=${UBOOT_UINITRD:-"uInitrd"}
126 ubootAddress=${UBOOT_IMGADDR:-"0x00008000"}
127 mounted=""
128 liloFlag=""
129 isx86=""
130 else
131 # this leaves i?86 and x86_64
132 liloConfig=/etc/lilo.conf
133 grubConfig=/boot/grub/grub.conf
134 grub2Config=/boot/grub/grub.cfg
135 grub2EfiConfig=/boot/grub/grub-efi.cfg
136 extlinuxConfig=/boot/extlinux/extlinux.conf
137 bootPrefix=/boot
138 liloFlag=lilo
139 isx86="yes"
140 fi
141
142 mode=""
143 version=""
144 initrd=""
145 dracut=""
146 dracuthostonly=""
147 initrdfile=""
148 moddep=""
149 verbose=""
150 makedefault=""
151 package=""
152 mbkernel="${HYPERVISOR}"
153 mbargs="${HYPERVISOR_ARGS}"
154 adddracutargs=""
155 addplymouthinitrd=""
156
157 usage()
158 {
159 echo "Usage: $(basename $0) [-v] [--mkinitrd] [--rminitrd] [--dracut]" >&2
160 echo " [--initrdfile=<initrd-image>] [--depmod] [--rmmoddep]" >&2
161 echo " [--kernel-args=<args>] [--remove-args=<args>]" >&2
162 echo " [--banner=<banner>] [--multiboot=multiboot]" >&2
163 echo " [--mbargs=mbargs] [--make-default] [--add-dracut-args]" >&2
164 echo " [--add-plymouth-initrd]" >&2
165 echo " [--host-only]" >&2
166 echo " <--install | --remove | --update> <kernel-version>" >&2
167 echo " (ex: $(basename $0) --mkinitrd --depmod --install 2.4.7-2)" >&2
168 exit 1
169 }
170
171 install()
172 {
173 # XXX kernel should be able to be specified also (or work right on ia64)
174 if [ ! -f ${kernelImage} ]
175 then
176 [[ -n ${verbose} ]] && echo "kernel for ${version} does not exist, not running grubby"
177 return
178 fi
179
180 INITRD=""
181 if [ -f ${initrdfile} ]
182 then
183 [[ -n ${verbose} ]] && echo "found ${initrdfile} and using it with grubby"
184 INITRD="--initrd ${initrdfile}"
185
186 if [[ -n ${addplymouthinitrd} ]]
187 then
188 INITRD="${INITRD} --extra-initrd ${bootPrefix}/initrd-plymouth.img"
189 fi
190 fi
191
192 # FIXME: is this a good heuristic to find out if we're on iSeries?
193 if [ -d /proc/iSeries ]
194 then
195 [[ -n ${verbose} ]] && echo "On an iSeries, just making img file"
196 if [[ -z ${initrdfile} ]]
197 then
198 [[ -n ${verbose} ]] && echo "No initrd, just adding system map"
199 /sbin/addSystemMap ${bootPrefix}/System.map-${version} ${kernelImage} ${bootPrefix}/vmlinitrd-${version}
200 else
201 /sbin/addSystemMap ${bootPrefix}/System.map-${version} ${kernelImage} ${bootPrefix}/vmlinux.sm-${version}
202 /sbin/addRamDisk ${initrdfile} ${bootPrefix}/System.map-${version} ${bootPrefix}/vmlinux.sm-${version} ${bootPrefix}/vmlinitrd-${version} 2>/dev/null
203 rm ${bootPrefix}/vmlinux.sm-${version}
204 fi
205 return
206 fi
207
208 # get the root filesystem to use
209 rootdevice=$(awk '{ if ($1 !~ /^[ \t]*#/ && $2 == "/") { print $1; }}' /etc/fstab 2>/dev/null)
210 if [[ -z $rootdevice ]]
211 then
212 rootdevice=$(grep -o -P "(?<=root=)\S+" /proc/cmdline)
213 fi
214
215 if [[ -n ${mbkernel} ]] && [[ -n ${cfgLilo} ]] && [[ ${liloFlag} != elilo ]]
216 then
217 [[ -n ${verbose} ]] && echo "multiboot specified, not updating lilo.conf"
218 cfgLilo=""
219 fi
220
221 if [[ -n ${banner} ]]
222 then
223 title="${banner} [ ${version} ]"
224 elif [[ $(read_os_release id) = magellan ]]
225 then
226 title="$(read_os_release name) $(read_os_release version_id) [ ${version} ]"
227 elif [ -f /etc/mageversion ]
228 then
229 title="Magellan Linux $(< /etc/mageversion) [ ${version} ]"
230 else
231 title="Magellan Linux [ ${version} ]"
232 fi
233
234 if [[ -n ${cfgGrub} ]]
235 then
236 [[ -n ${verbose} ]] && echo "adding ${version} to ${grubConfig}"
237
238 ${grubby} --grub -c ${grubConfig} \
239 --add-kernel=${kernelImage} \
240 ${INITRD} --copy-default ${makedefault} --title "${title}" \
241 ${mbkernel:+--add-multiboot="${mbkernel}"} ${mbargs:+--mbargs="${mbargs}"} \
242 --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
243 else
244 [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby for grub 0.97"
245 fi
246 if [[ -n ${cfgGrub2} ]]
247 then
248 [[ -n ${verbose} ]] && echo "adding ${version} to ${grub2Config}"
249
250 ${grubby} --grub2 -c ${grub2Config} \
251 --add-kernel=${kernelImage} \
252 ${INITRD} --copy-default ${makedefault} --title "${title}" \
253 ${mbkernel:+--add-multiboot="${mbkernel}"} \
254 ${mbargs:+--mbargs="${mbargs}"} \
255 --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
256 else
257 [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby for grub 2"
258 fi
259 if [[ -n ${cfgGrub2Efi} ]]
260 then
261 [[ -n ${verbose} ]] && echo "adding ${version} to ${grub2EfiConfig}"
262
263 ${grubby} --grub2 -c ${grub2EfiConfig} --efi \
264 --add-kernel=${kernelImage} \
265 ${INITRD} --copy-default ${makedefault} --title "${title}" \
266 ${mbkernel:+--add-multiboot="${mbkernel}"} \
267 ${mbargs:+--mbargs="${mbargs}"} \
268 --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
269 else
270 [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby for grub 2 with UEFI"
271 fi
272
273 if [[ -n ${cfgLilo} ]]
274 then
275 [[ -n ${verbose} ]] && echo "adding ${version} to ${liloConfig}"
276
277 ${grubby} --add-kernel=${kernelImage} ${INITRD} \
278 --copy-default ${makedefault} --title ${version} \
279 ${mbkernel:+--add-multiboot="${mbkernel}"} ${mbargs:+--mbargs="${mbargs}"} \
280 --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${version}" \
281 --${liloFlag}
282
283 if [[ -n ${runLilo} ]]
284 then
285 [[ -n ${verbose} ]] && echo "running ${lilo}"
286 if [ ! -x ${lilo} ]
287 then
288 [[ -n ${verbose} ]] && echo "${lilo} does not exist"
289 else
290 ${lilo} > /dev/null
291 fi
292 fi
293 else
294 [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
295 fi
296
297 if [[ -n ${cfgExtlinux} ]]
298 then
299 [[ -n ${verbose} ]] && echo "adding ${version} to ${extlinuxConfig}"
300
301 ${grubby} --extlinux -c ${extlinuxConfig} \
302 --add-kernel=${kernelImage} \
303 ${INITRD} --copy-default ${makedefault} --title "${title}" \
304 ${mbkernel:+--add-multiboot="${mbkernel}"} ${mbargs:+--mbargs="${mbargs}"} \
305 --args="root=${rootdevice} ${kernargs}" --remove-kernel="TITLE=${title}"
306 else
307 [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby for extlinux"
308 fi
309 }
310
311 remove()
312 {
313 # FIXME: is this a good heuristic to find out if we're on iSeries?
314 if [ -d /proc/iSeries ]
315 then
316 [[ -n ${verbose} ]] && echo "On an iSeries, remove img file"
317 rm -f ${kernelImage}.img 2>/dev/null
318 return
319 fi
320
321 if [[ -n ${cfgGrub} ]]
322 then
323 [[ -n ${verbose} ]] && echo "removing ${version} from ${grubConfig}"
324 ${grubby} --grub -c ${grubConfig} \
325 --remove-kernel=${kernelImage}
326 else
327 [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby for grub 0.97"
328 fi
329 if [[ -n ${cfgGrub2} ]]
330 then
331 [[ -n ${verbose} ]] && echo "removing ${version} from ${grub2Config}"
332 ${grubby} --grub2 -c ${grub2Config} \
333 --remove-kernel=${kernelImage}
334 else
335 [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby for grub 2"
336 fi
337 if [[ -n ${cfgGrub2Efi} ]]
338 then
339 [[ -n ${verbose} ]] && echo "removing ${version} from ${grub2EfiConfig}"
340 ${grubby} --grub2 -c ${grub2EfiConfig} --efi \
341 --remove-kernel=${kernelImage}
342 else
343 [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby grub 2 with UEFI"
344 fi
345
346 if [[ -n ${cfgLilo} ]]
347 then
348 [[ -n ${verbose} ]] && echo "removing ${version} from ${liloConfig}"
349 ${grubby} --remove-kernel=${kernelImage} --${liloFlag}
350
351 if [[ -n ${runLilo} ]]
352 then
353 [[ -n ${verbose} ]] && echo "running ${lilo}"
354 if [ ! -x ${lilo} ]
355 then
356 [[ -n ${verbose} ]] && echo "${lilo} does not exist"
357 else
358 ${lilo} > /dev/null
359 fi
360 fi
361 else
362 [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
363 fi
364
365 if [[ -n ${cfguBoot} ]]
366 then
367 [[ -n ${verbose} ]] && echo "removing ${version} from ${ubootDir}..."
368
369 if [ -f ${ubootDir}/${ubootKList} ]
370 then
371 tmpKList=$(mktemp ${ubootDir}/${ubootKList}.XXXX)
372 curversion=$(tail -n1 ${ubootDir}/${ubootKList})
373 sed "/$version$/d" ${ubootDir}/${ubootKList} > ${tmpKList}
374 newversion=$(tail -n1 ${tmpKList})
375 if [ -f ${ubootDir}/uImage-${newversion} ] && [ -f ${ubootDir}/uInitrd-${newversion} ]
376 then
377 if [[ ${curversion} != ${newversion} ]]
378 then
379 cp -fp ${ubootDir}/uImage-${newversion} ${ubootDir}/${ubootDefaultImage}
380 if [ $? -ne 0 ]
381 then
382 [[ -n ${verbose} ]] && echo "copy uImage-${newversion} error, default kernel not replaced!" && exit
383 fi
384 cp -fp ${ubootDir}/uInitrd-${newversion} ${ubootDir}/${ubootDefaultInitrd}
385 if [ $? -ne 0 ]
386 then
387 [[ -n ${verbose} ]] && echo "copy uInitrd-${newversion} error, default Initrd not replaced!" && exit
388 fi
389 fi
390
391 [[ -n ${verbose} ]] && echo "removing uImage-${version}"
392 if [ -f ${ubootDir}/uImage-${version} ]
393 then
394 rm -f ${ubootDir}/uImage-${version}
395 else
396 [[ -n ${verbose} ]] && echo "uImage-${version} did not exist!"
397 fi
398
399 [[ -n ${verbose} ]] && echo "removing uInitrd-${version}"
400 if [ -f ${ubootDir}/uInitrd-${version} ]
401 then
402 rm -f ${ubootDir}/uInitrd-${version}
403 else
404 [[ -n ${verbose} ]] && echo "uInitrd-${version} did not exist!"
405 fi
406
407 mv ${tmpKList} ${ubootDir}/${ubootKList}
408 [ -x /sbin/a-b-c ] && /sbin/a-b-c
409 else
410 [[ -n ${verbose} ]] && echo "uImage ${newversion} does not exist!"
411 [ -f ${tmpKList} ] && rm -f ${tmpKList}
412 fi
413 else
414 [[ -n ${verbose} ]] && echo "No previous kernel version. U-Boot images not removed!"
415 fi
416 else
417 [[ -n ${verbose} ]] && echo "${ubootScript} does not exist, not modifying ${ubootDir}"
418 fi
419
420 if [[ -n ${cfgExtlinux} ]]
421 then
422 [[ -n ${verbose} ]] && echo "removing ${version} from ${extlinuxConfig}"
423 ${grubby} --extlinux -c ${extlinuxConfig} \
424 --remove-kernel=${kernelImage}
425 else
426 [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby for extlinux"
427 fi
428 }
429
430 update()
431 {
432 if [ ! -f ${kernelImage} ]
433 then
434 [[ -n ${verbose} ]] && echo "kernel for ${version} does not exist, not running grubby"
435 return
436 fi
437
438 INITRD=""
439 if [ -f ${initrdfile} ]
440 then
441 [[ -n ${verbose} ]] && echo "found ${initrdfile} and using it with grubby"
442 INITRD="--initrd ${initrdfile}"
443
444 if [[ -n ${addplymouthinitrd} ]]
445 then
446 INITRD="${INITRD} --extra-initrd ${bootPrefix}/initrd-plymouth.img"
447 fi
448 fi
449
450 if [[ -n ${cfgGrub} ]]
451 then
452 [[ -n ${verbose} ]] && echo "updating ${version} from ${grubConfig}"
453 ${grubby} --grub -c ${grubConfig} \
454 --update-kernel=${kernelImage} \
455 ${INITRD} \
456 ${kernargs:+--args="${kernargs}"} \
457 ${removeargs:+--remove-args="${removeargs}"} \
458 ${mbkernel:+--add-multiboot="${mbkernel}"}
459 else
460 [[ -n ${verbose} ]] && echo "${grubConfig} does not exist, not running grubby"
461 fi
462
463 if [[ -n ${cfgGrub2} ]]
464 then
465 [[ -n ${verbose} ]] && echo "updating ${version} from ${grub2Config}"
466 ${grubby} --grub2 -c ${grub2Config} \
467 --update-kernel=${kernelImage} \
468 ${INITRD} \
469 ${kernargs:+--args="${kernargs}"} \
470 ${removeargs:+--remove-args="${removeargs}"}
471 else
472 [[ -n ${verbose} ]] && echo "${grub2Config} does not exist, not running grubby"
473 fi
474
475 if [[ -n ${cfgGrub2Efi} ]]
476 then
477 [[ -n ${verbose} ]] && echo "updating ${version} from ${grub2EfiConfig}"
478 ${grubby} --grub2 -c ${grub2EfiConfig} --efi \
479 --update-kernel=${kernelImage} \
480 ${INITRD} \
481 ${kernargs:+--args="${kernargs}"} \
482 ${removeargs:+--remove-args="${removeargs}"}
483 else
484 [[ -n ${verbose} ]] && echo "${grub2EfiConfig} does not exist, not running grubby"
485 fi
486
487 if [[ -n ${cfgLilo} ]]
488 then
489 [[ -n ${verbose} ]] && echo "updating ${version} from ${liloConfig}"
490 ${grubby} --update-kernel=${kernelImage} \
491 ${INITRD} \
492 ${kernargs:+--args="${kernargs}"} \
493 ${removeargs:+--remove-args="${removeargs}"} \
494 --${liloFlag}
495
496 if [[ -n ${runLilo} ]]
497 then
498 [[ -n ${verbose} ]] && echo "running ${lilo}"
499 if [ ! -x ${lilo} ]
500 then
501 [[ -n ${verbose} ]] && echo "${lilo} does not exist"
502 else
503 ${lilo} > /dev/null
504 fi
505 fi
506 else
507 [[ -n ${verbose} ]] && echo "${liloConfig} does not exist, not running grubby"
508 fi
509
510 if [[ -n ${cfguBoot} ]]
511 then
512 [[ -n ${verbose} ]] && echo "adding $version to ${ubootDir}..."
513
514 [[ -n ${verbose} ]] && echo "creating uImage-${version}"
515 mkimage -A arm -O linux -T kernel -C none -a ${ubootAddress} \
516 -e ${ubootAddress} -n ${version} \
517 -d ${kernelImage} ${ubootDir}/uImage-${version}
518
519 [[ -n ${verbose} ]] && echo "creating uInitrd-${version}"
520 mkimage -A arm -O linux -T ramdisk -C none -a 0 -e 0 \
521 -n initramfs -d ${initrdfile} ${ubootDir}/uInitrd-${version}
522
523 if [ -f ${ubootDir}/uImage-${version} ] && [ -f ${ubootDir}/uInitrd-${version} ]
524 then
525 cp -fp ${ubootDir}/uImage-${version} ${ubootDir}/${ubootDefaultImage}
526 if [ $? -ne 0 ]
527 then
528 [[ -n ${verbose} ]] && echo "copy uImage-${version} error, kernel not installed!" && exit
529 fi
530 cp -fp ${ubootDir}/uInitrd-${version} ${ubootDir}/${ubootDefaultInitrd}
531 if [ $? -ne 0 ]
532 then
533 [[ -n ${verbose} ]] && echo "copy uInitrd-${version} error, kernel not installed!" && exit
534 fi
535 echo ${version} >> ${ubootDir}/${ubootKList}
536 [ -x /sbin/a-b-c ] && /sbin/a-b-c
537 else
538 [[ -n ${verbose} ]] && echo "cannot make ${version} the default"
539 fi
540 else
541 [[ -n ${verbose} ]] && echo "${ubootScript} does not exist, not setting up ${ubootDir}"
542 fi
543
544 if [[ -n ${cfgExtlinux} ]]
545 then
546 [[ -n ${verbose} ]] && echo "updating ${version} from ${extlinuxConfig}"
547 ${grubby} --extlinux -c ${extlinuxConfig} \
548 --update-kernel=${kernelImage} \
549 ${INITRD} \
550 ${kernargs:+--args="${kernargs}"} \
551 ${removeargs:+--remove-args="${removeargs}"}
552 else
553 [[ -n ${verbose} ]] && echo "${extlinuxConfig} does not exist, not running grubby"
554 fi
555 }
556
557 makeinitrd()
558 {
559 if [[ -n ${dracut} ]]
560 then
561 tool="dracut ${dracuthostonly} -f ${initrdfile} ${version}"
562 else
563 tool="mkinitrd --allow-missing -f ${initrdfile} ${version}"
564 fi
565 [[ -n ${verbose} ]] && echo "creating initrd ${initrdfile} using ${version}"
566 ${tool}
567 rc=$?
568 if [ ${rc} != 0 ]
569 then
570 echo "mkinitrd failed" >&2
571 exit 1
572 fi
573 }
574
575 rminitrd()
576 {
577 [[ -n ${verbose} ]] && echo "removing initrd ${initrdfile}"
578 [ -f ${initrdfile} ] && rm -f ${initrdfile}
579 }
580
581 doDepmod()
582 {
583 [[ -n ${verbose} ]] && echo "running depmod for ${version}"
584 depmod -ae -F /boot/System.map-${version} ${version}
585 }
586
587 doRmmoddep()
588 {
589 [[ -n ${verbose} ]] && echo "removing modules.dep info for ${version}"
590 if [ -d /lib/modules/${version} ]
591 then
592 rm -f /lib/modules/${version}/modules.*.bin \
593 /lib/modules/${version}/modules.{alias,dep,devname,symbols,softdep}
594 fi
595 }
596
597
598 while [ $# -gt 0 ]
599 do
600 case $1 in
601 --mkinitrd)
602 initrd="make"
603 ;;
604
605 --rminitrd)
606 initrd="remove"
607 ;;
608
609 --dracut)
610 dracut=--dracut
611 ;;
612
613 --host-only)
614 dracuthostonly=-H
615 ;;
616
617 --initrdfile*)
618 if [[ $1 == --initrdfile\=* ]]
619 then
620 initrdfile=${1#--initrdfile=}
621 else
622 initrdfile=$2
623 shift
624 fi
625 ;;
626
627 --kernel-args*)
628 if [[ $1 == --kernel-args\=* ]]
629 then
630 kernargs=${1#--kernel-args=}
631 else
632 kernargs=$2
633 shift
634 fi
635 ;;
636
637 --remove-args*)
638 if [[ $1 == --remove-args\=* ]]
639 then
640 removeargs=${1#--remove-args=}
641 else
642 removeargs=$2
643 shift
644 fi
645 ;;
646
647 --banner*)
648 if [[ $1 == --banner\=* ]]
649 then
650 banner=${1#--banner=}
651 else
652 banner=$2
653 shift
654 fi
655 ;;
656
657 --multiboot*)
658 if [[ $1 == --multiboot\=* ]]
659 then
660 mbkernel=${1#--multiboot=}
661 else
662 # can't really support having an optional second arg here
663 # sorry!
664 mbkernel="/boot/xen.gz"
665 fi
666 ;;
667
668 --mbargs*)
669 if [[ $1 == --mbargs\=* ]]
670 then
671 mbargs=${1#--mbargs=}
672 else
673 mbargs="$2"
674 shift
675 fi
676 ;;
677
678 --depmod)
679 moddep="make"
680 ;;
681
682 --rmmoddep)
683 moddep="remove"
684 ;;
685
686 --make-default)
687 makedefault="--make-default"
688 ;;
689
690 --package*)
691 if [[ $1 == --package\=* ]]
692 then
693 package=${1#--package=}
694 else
695 package=$2
696 shift
697 fi
698 ;;
699
700 --add-dracut-args)
701 adddracutargs=--add-dracut-args
702 ;;
703
704 --add-plymouth-initrd)
705 addplymouthinitrd=--add-plymouth-initrd
706 ;;
707
708 --kernel-image*)
709 if [[ $1 == --kernel-image\=* ]]
710 then
711 kernelImage=${1#--kernel-image=}
712 else
713 kernelImage="$2"
714 shift
715 fi
716 if ! [[ -f ${kernelImage} ]]
717 then
718 echo "Can't find kernel image '${kernelImage}'" >&2
719 usage
720 exit 1
721 fi
722 ;;
723
724 -v)
725 verbose=-v
726 ;;
727
728 *)
729 if [[ -z ${mode} ]]
730 then
731 mode=$1
732 elif [[ -z ${version} ]]
733 then
734 version=$1
735 else
736 usage
737 fi
738 ;;
739 esac
740
741 shift
742 done
743
744 # make sure the mode is valid
745 if [[ ${mode} != --install ]] && [[ ${mode} != --remove ]] && [[ ${mode} != --update ]]
746 then
747 usage
748 fi
749
750 if [[ -z ${version} ]]
751 then
752 usage
753 fi
754
755 if [ "${mode}" != "--install" -a "${makedefault}" ]
756 then
757 usage
758 fi
759
760 kernelmajor=$(echo ${kernel} | cut -d . -f 1,2)
761
762 # kernel image for 2.4 is kernel
763 if [[ ${ARCH} = ppc64 ]] || [[ ${ARCH} = ppc ]]
764 then
765 if [[ ${kernelmajor} = 2.4 ]]
766 then
767 kernelName=kernel
768 fi
769 fi
770
771 [[ ${kernelImage} ]] || kernelImage="${bootPrefix}/${kernelName}-${version}"
772
773 # set the initrd file based on arch; ia64 is the only currently known oddball
774 if [[ -z ${initrdfile} ]]
775 then
776 INITRD_NAME_PREFIX="initrd"
777 if [[ -n ${dracut} ]]
778 then
779 INITRD_NAME_PREFIX="initramfs"
780 fi
781
782 if [[ $(uname -m) = ia64 ]]
783 then
784 initrdfile="/boot/efi/EFI/redhat/${INITRD_NAME_PREFIX}-${version}.img"
785 else
786 initrdfile="/boot/${INITRD_NAME_PREFIX}-${version}.img"
787 fi
788 fi
789 [[ -n ${verbose} ]] && echo "initrdfile is ${initrdfile}"
790
791 # add dracut i18n, keyboard and plymouth kernel args if requested
792 if [[ -n ${dracut} ]] || [[ -n ${adddracutargs} ]]
793 then
794 if [ -r /etc/vconsole.conf ]
795 then
796 . /etc/vconsole.conf
797
798 for i in SYSFONT SYSFONTACM UNIMAP KEYTABLE
799 do
800 val=$(eval echo \$$i)
801 [[ -n ${val} ]] && kernargs="${kernargs} ${i}=${val}"
802 done
803 else
804 if [ -r /etc/conf.d/consolefont ]
805 then
806 . /etc/conf.d/consolefont
807
808 if [[ -n ${CONSOLEFONT} ]]
809 then
810 kernargs="${kernargs} SYSFONT=${CONSOLEFONT}"
811 fi
812 fi
813
814 if [ -r /etc/conf.d/keymap ]
815 then
816 . /etc/conf.d/keymap
817
818 if [[ -n ${KEYMAP} ]]
819 then
820 kernargs="${kernargs} KEYTABLE=${KEYMAP}"
821 fi
822 fi
823 fi
824
825 if [ -r /etc/locale.conf ]
826 then
827 . /etc/locale.conf
828
829 if [[ -n ${LANG} ]]
830 then
831 kernargs="${kernargs} LANG=${LANG}"
832 fi
833 fi
834 fi
835
836 # set this as the default if we have the package and it matches
837 if [[ ${mode} = --install ]] && [[ ${UPDATEDEFAULT} = yes ]] && [[ -n ${package} ]] &&
838 [[ -n ${DEFAULTKERNEL} ]] && [[ ${package} = ${DEFAULTKERNEL} ]]
839 then
840 makedefault="--make-default"
841 [[ -n ${verbose} ]] && echo "making it the default based on config"
842 fi
843
844 if [[ ${moddep} = make ]]
845 then
846 doDepmod
847 elif [[ ${moddep} = remove ]]
848 then
849 doRmmoddep
850 fi
851
852 if [[ ${initrd} = make ]]
853 then
854 makeinitrd
855 elif [[ ${initrd} = remove ]]
856 then
857 rminitrd
858 fi
859
860 if [ ! -x ${grubby} ]
861 then
862 [[ -n ${verbose} ]] && echo "${grubby} does not exist"
863 exit 0
864 fi
865
866 [[ -n ${grubConfig} ]] && [ -f ${grubConfig} ] && cfgGrub=1
867 [[ -n ${grub2Config} ]] && [ -f ${grub2Config} ] && cfgGrub2=1
868 [[ -n ${grub2EfiConfig} ]] && [ -f ${grub2EfiConfig} ] && cfgGrub2Efi=1
869 [[ -n ${liloConfig} ]] && [ -f ${liloConfig} ] && cfgLilo=1
870 [[ -n ${extlinuxConfig} ]] && [ -f ${extlinuxConfig} ] && cfgExtlinux=1
871
872 # if we have a U-Boot directory, but no boot script, check if the directory
873 # is mounted. If not, mount it, and then check if a boot script exists.
874 if [[ -n ${ubootDir} ]]
875 then
876 if [ -f ${ubootScript} ]
877 then
878 cfguBoot=1
879 else
880 mountEntry=$(mount | grep ${ubootDir})
881 if [[ -z ${mountEntry} ]]
882 then
883 mount ${ubootDevice} ${ubootDir}
884 mounted=1
885 fi
886 [ -f ${ubootScript} ] && cfguBoot=1
887 fi
888 fi
889
890 # if we're using U-Boot, check if the default load address should change
891 if [[ -n ${cfguBoot} ]] && [[ -z ${UBOOT_IMGADDR} ]]
892 then
893 [[ ${version} =~ .([^.]*)$ ]]
894 platform=${BASH_REMATCH[1]}
895 # A few platforms use an alternate kernel load address
896 if [[ ${platform} = omap ]]
897 then
898 ubootAddress=0x80008000
899 elif [[ ${platform} = imx ]]
900 then
901 ubootAddress=0x90008000
902 fi
903 fi
904
905 # if we have a lilo config on an x86 box, see if the default boot loader
906 # is lilo to determine if it should be run
907 if [[ -n ${cfgLilo} ]] && [[ -n ${isx86} ]]
908 then
909 runLilo=$(${grubby} --bootloader-probe | grep lilo)
910 fi
911
912 if [[ ${mode} = --install ]]
913 then
914 install
915 elif [[ ${mode} = --remove ]]
916 then
917 remove
918 elif [[ ${mode} = --update ]]
919 then
920 update
921 fi
922
923 # if we mounted the U-Boot directory, unmount it.
924 [[ -n ${mounted} ]] && umount ${ubootDir}
925
926 exit 0

Properties

Name Value
svn:executable *